"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DEFAULT = {
  catchCode: function catchCode(identifier) {
    return "console.error(".concat(identifier, ")");
  },
  identifier: 'e',
  finallyCode: null
};
/**
 * 参数满足含有 async 关键字的
 * 函数声明
 * 箭头函数
 * 函数表达式
 * 方法
 * 则返回 true
 * **/

var isAsyncFuncNode = function isAsyncFuncNode(node, t) {
  return t.isFunctionDeclaration(node, {
    async: true
  }) || t.isArrowFunctionExpression(node, {
    async: true
  }) || t.isFunctionExpression(node, {
    async: true
  }) || t.isObjectMethod(node, {
    async: true
  });
};
/**
 *  只给最外层的 async 函数包裹 try/catch
 * **/


var _default = function _default(_ref) {
  var t = _ref.types,
      parse = _ref.parse;
  return {
    visitor: {
      AwaitExpression: function AwaitExpression(path, _ref2) {
        var opts = _ref2.opts;

        var options = _objectSpread(_objectSpread({}, DEFAULT), opts);

        if (typeof options.catchCode === 'function') {
          options.catchCode = options.catchCode(options.identifier);
        }

        var catchNode = parse(options.catchCode).program.body;
        var finallyNode = options.finallyCode && parse(options.finallyCode).program.body; // 递归向上找异步函数的 node 节点

        while (path && path.node) {
          var parentPath = path.parentPath;

          if ( // 找到 async Function
          t.isBlockStatement(path.node) && isAsyncFuncNode(parentPath.node, t)) {
            var tryCatchAst = t.tryStatement(path.node, t.catchClause(t.identifier(options.identifier), t.blockStatement(catchNode)), finallyNode && t.blockStatement(finallyNode));
            path.replaceWithMultiple([tryCatchAst]);
            return;
          } else if ( // 已经包含 try 语句则直接退出
          t.isBlockStatement(path.node) && t.isTryStatement(parentPath.node)) {
            return;
          }

          path = parentPath;
        }
      }
    }
  };
};

exports["default"] = _default;